Attribute VB_Name = "modFileUnicode"
Option Explicit

Private Type OPENFILENAME_WCHAR
  lStructSize As Long
  hwndOwner As Long
  hInstance As Long
  lpstrFilter As Long
  lpstrCustomFilter As Long
  nMaxCustFilter As Long
  nFilterIndex As Long
  lpstrFile As Long
  nMaxFile As Long
  lpstrFileTitle As Long
  nMaxFileTitle As Long
  lpstrInitialDir As Long
  lpstrTitle As Long
  flags As Long
  nFileOffset As Integer
  nFileExtension As Integer
  lpstrDefExt As Long
  lCustData As Long
  lpfnHook As Long
  lpTemplateName As Long
End Type

Private Const OFN_OVERWRITEPROMPT = &H2
Private Const OFN_HIDEREADONLY = &H4
Private Const OFN_ALLOWMULTISELECT = &H200
Private Const OFN_FILEMUSTEXIST = &H1000
Private Const OFN_PATHMUSTEXIST = &H800
Private Const OFN_CREATEPROMPT = &H2000
Private Const OFN_EXPLORER = &H80000


Private Declare Function GetSaveFileName Lib "comdlg32.dll" _
  Alias "GetSaveFileNameW" (pOpenfilename As OPENFILENAME_WCHAR) _
  As Long
Private Declare Function GetOpenFileName Lib "comdlg32.dll" _
  Alias "GetOpenFileNameW" (pOpenfilename As OPENFILENAME_WCHAR) _
  As Long

Private Declare Function GetShortPathName Lib "kernel32" _
  Alias "GetShortPathNameW" (ByVal lpszLongPath As Long, _
  ByVal lpszShortPath As Long, ByVal cchBuffer As Long) _
  As Long

'ffnen-Dialog
Public Function ShowOpenDlg(F As Form, strFilter As String, _
  strTitel As String, strInitDir As String) As String

  Dim lngOpenFileName As OPENFILENAME_WCHAR
  Dim lngAnt As Long
  Dim strFile As String
  

  With lngOpenFileName
    .lStructSize = Len(lngOpenFileName)
    .hwndOwner = F.hWnd
    .hInstance = App.hInstance

    strFilter = Replace$(strFilter, "|", vbNullChar)
    Do Until Right$(strFilter, 2) = vbNullChar & vbNullChar ' Der Filter muss immer durch 2 NullChars terminiert werden
      strFilter = strFilter & vbNullChar
    Loop

    strFile = String$(20480, 0)
    .lpstrFilter = StrPtr(strFilter)
    .lpstrFile = StrPtr(strFile)
    .nMaxFile = Len(strFile)
    .lpstrInitialDir = StrPtr(strInitDir)
    .lpstrTitle = StrPtr(strTitel)
    .flags = OFN_FILEMUSTEXIST Or OFN_EXPLORER Or OFN_PATHMUSTEXIST

    lngAnt = GetOpenFileName(lngOpenFileName)
    If lngAnt Then
      lngAnt = InStr(1, strFile, vbNullChar)
      If lngAnt <> 0 Then
         strFile = Left$(strFile, lngAnt - 1)
      End If
      ShowOpenDlg = strFile
    Else
      ShowOpenDlg = vbNullString
    End If
  End With
End Function

'Speichern-Dialog
Public Function ShowSaveDlg(F As Form, strFilter As String, _
  strTitel As String, strInitDir As String) As String

  Dim lngOpenFileName As OPENFILENAME_WCHAR
  Dim lngAnt As Long
  
  With lngOpenFileName
    .lStructSize = Len(lngOpenFileName)
    .hwndOwner = F.hWnd
    .hInstance = App.hInstance
    If Right$(strFilter, 1) <> "|" Then _
      strFilter = strFilter + "|"

    For lngAnt = 1 To Len(strFilter)
      If Mid$(strFilter, lngAnt, 1) = "|" Then _
        Mid$(strFilter, lngAnt, 1) = vbNullChar
    Next
    
    .lpstrFilter = strFilter
    .lpstrFile = Space$(254)
    .nMaxFile = 255
    .lpstrFileTitle = Space$(254)
    .nMaxFileTitle = 255
    .lpstrInitialDir = strInitDir
    .lpstrTitle = strTitel
    .flags = OFN_HIDEREADONLY Or OFN_OVERWRITEPROMPT Or _
      OFN_CREATEPROMPT

    lngAnt = GetSaveFileName(lngOpenFileName)
    If (lngAnt) Then
      ShowSaveDlg = Trim$(.lpstrFile)
    Else
      ShowSaveDlg = vbNullString
    End If
  End With
End Function

Public Function GetShortName(ByVal strLongName As String) _
  As String

  Dim ShortName As String
  Dim sLen As Long
  
  ShortName = Space$(256)
  sLen = GetShortPathName(StrPtr(strLongName), StrPtr(ShortName), Len(ShortName))
  ShortName = Left$(ShortName, sLen)

  GetShortName = ShortName
End Function
